<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_practice_specialty".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderPracticeSpecialty".
 *
 * Columns in table "provider_practice_specialty" available as properties of the model,
 * followed by relations of table "provider_practice_specialty" available as properties of the model.
 *
 * @property integer $id
 * @property integer $provider_id
 * @property integer $practice_id
 * @property integer $accepts_new_patients
 * @property integer $sub_specialty_id
 * @property integer $specialty_id
 *
 * @property Provider $provider
 * @property Practice $practice
 * @property Specialty $subSpecialty
 * @property Specialty $specialty
 */
abstract class BaseProviderPracticeSpecialty extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_practice_specialty';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderPracticeSpecialty|ProviderPracticeSpecialties', $n);
    }

    public static function representingColumn()
    {
        return 'id';
    }

    public function rules()
    {
        return array(
            array('id, provider_id, practice_id, accepts_new_patients', 'required'),
            array('id, provider_id, practice_id, accepts_new_patients, sub_specialty_id, specialty_id',
                'numerical', 'integerOnly' => true),
            array('sub_specialty_id, specialty_id', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, provider_id, practice_id, accepts_new_patients, sub_specialty_id, specialty_id',
                'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
            'subSpecialty' => array(self::BELONGS_TO, 'Specialty', 'sub_specialty_id'),
            'specialty' => array(self::BELONGS_TO, 'Specialty', 'specialty_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'provider_id' => null,
            'practice_id' => null,
            'accepts_new_patients' => Yii::t('app', 'Accepts New Patients'),
            'sub_specialty_id' => null,
            'specialty_id' => null,
            'provider' => null,
            'practice' => null,
            'subSpecialty' => null,
            'specialty' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('accepts_new_patients', $this->accepts_new_patients);
        $criteria->compare('sub_specialty_id', $this->sub_specialty_id);
        $criteria->compare('specialty_id', $this->specialty_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
